chiark / gitweb /
Merge remote-tracking branch 'staging/master'
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure \
108         --prefix=$HOME$sub \
109         PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110         >>buildlog 2>&1
111       $echon " building$echoc"
112       make >>buildlog 2>&1
113       $echon " installing$echoc"
114       make install >>buildlog 2>&1
115       echo " done."
116     )
117   fi
118 done
119 echo "  all done."
120
121 ###--------------------------------------------------------------------------
122 ### Install global configuration.
123
124 echo -n "Installing dotfile configuration:"
125 if [ -f $HOME$sub/.mdw.conf ]; then
126   echo " already installed."
127 else
128   cp mdw.conf $HOME$sub/.mdw.conf
129   echo " done."
130 fi
131
132 ## Symlink the various dotfiles into place
133 dotfiles="
134   bash_profile bash_logout bashrc inputrc bash_completion
135   emacs emacs-calc vm gnus.el ercrc.el
136   vimrc mg zile lesskey
137   ditz-config
138   mailrc signature muttrc
139   cgrc tigrc
140   gdbinit
141   guile
142   rcrc
143   toprc
144   mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
145   aspell.conf
146   tclshrc:.tclshrc tclshrc:.wishrc
147   lisp-init.lisp:.cmucl-init.lisp
148     lisp-init.lisp:.sbclrc
149     lisp-init.lisp:.clisprc.lisp
150     lisp-init.lisp:.eclrc
151   swank.lisp
152   w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
153   dircolors colordiffrc screenrc cvsrc indent.pro"
154 [ "$xstuff" ] && dotfiles="$dotfiles
155   xinitrc xsession xmodmap Xdefaults vncrc vncsession
156   fonts.conf
157   stalonetrayrc
158   putty-defaults:.putty/sessions/Default%20Settings
159   mdw.session:.config/gnome-session/sessions/mdw.session
160   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
161   e-keybindings.cfg:.enlightenment/keybindings.cfg
162   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
163   e16-bindings:.e16/bindings.cfg"
164 echo "Installing dotfiles..."
165 for d in $dotfiles; do
166   target=.$d
167   case $d in
168     *:*) target=${d#*:} d=${d%%:*};;
169   esac
170   ft=$HOME$sub/$target
171   dir=${ft%/*}
172   mkdir -p $dir
173   ln -s $here/dot/$d $ft.new
174   mv $ft.new $ft
175   echo "  $target"
176 done
177 echo "  all done."
178
179 ## Substitute things which need substituting.
180 dotfilessubst="
181   gitconfig
182   mykermrc
183   pulse-default.pa.in:.pulse/default.pa"
184 echo "Installing dotfiles with substitutions..."
185 for d in $dotfilessubst; do
186   case $d in
187     *:*) target=${d#*:} d=${d%%:*};;
188     *) target=.$d d=$d.in;;
189   esac
190   ft=$HOME$sub/$target
191   dir=${ft%/*}
192   mkdir -p $dir
193   sed "
194 1i\\
195 ### generated by $here/setup; do not edit!\\
196
197 /@home@/ s\a\a$HOME\ag
198 /@profile@/ s\a\a$here\ag
199 /@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
200 " dot/$d >$ft.new
201   mv $ft.new $ft
202   echo "  $target"
203 done
204 echo "  all done."
205
206 ## Symlink backgrounds.
207 backgrounds="
208   bsg-supper.jpg
209   harley-quinn.jpg
210   hypatia.jpg
211   jue-peek.jpg
212   lilith.jpg
213   lovelace.jpg
214   medusa.jpg
215   noodly.jpg
216   rayne.jpg
217 "
218 if [ "$xstuff" ]; then
219   echo "Installing backgrounds..."
220   for b in $backgrounds; do
221     for e in enlightenment e16; do
222       dir=$HOME$sub/.$e/backgrounds
223       t=$dir/$b
224       mkdir -p $dir
225       ln -s $here/bg/$b $t.new
226       mv $t.new $t
227     done
228     echo "  $b"
229   done
230   echo "        all done."
231 fi
232
233 ###--------------------------------------------------------------------------
234 ### Install useful scripts included in this package.
235
236 scripts="
237   mdw-editor
238   mdw-pager
239   mdw-conf
240   mdw-build
241   emacsclient-hack
242   movemail-hack
243   sendmail-hack
244   aspell-hack
245   emerge-hack
246   lesspipe.sh
247   start-ssh-agent
248   svnwrap
249   guest-console
250   hyperspec"
251 [ "$xstuff" ] && scripts="$scripts
252   xinitcmd
253   un-backslashify-selection
254   lock-screen
255   xshutdown"
256 echo "Installing scripts..."
257 mkdir -p $HOME$sub/bin
258 for s in $scripts; do
259   ft=$HOME$sub/bin/$s
260   ln -s $here/bin/$s $ft.new
261   mv $ft.new $ft
262   echo "  $s"
263 done
264 echo "  all done."
265
266 hacks="
267   ssh:ssh"
268 echo "Installing hacks..."
269 for h in $hacks; do
270   d=${h%%:*} h=${h#*:}
271   ft=$HOME$sub/bin/hacks/$d
272   mkdir -p $ft
273   ln -s $here/hacks/$h $ft/$h.new
274   mv $ft/$h.new $ft/$h
275   echo "  $d:$h"
276 done
277 echo "  all done."
278
279 ###--------------------------------------------------------------------------
280 ### Set up the Emacs config.
281
282 $echon "Finding a suitable emacs:$echoc"
283 emacs=no
284 for i in emacs22 emacs23 emacs21 emacs; do
285   if type -p >/dev/null $i; then
286     emacs=$i
287     break
288   fi
289 done
290 if [ $emacs = no ]; then
291   echo " failed."
292   emacs=:
293 else
294   echo " $emacs."
295 fi
296
297 echo "Installing Emacs packages..."
298 emacspkg="
299   make-regexp
300   ew-hols
301   mdw-gnus-patch
302   git git-blame vc-git stgit
303   mdw-multiple-cursors
304   quilt"
305 for elib in $emacspkg; do
306   $echon "  $elib:$echoc"
307   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
308        (progn
309          (setq load-path (nconc load-path (list "~/lib/emacs")))
310          (kill-emacs (condition-case nil
311                          (progn (load-library "'"$elib"'") 0)
312                        (error 1))))'; then
313     echo " already installed."
314   else
315     if [ -f el/$elib.el ]; then
316       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
317     else
318       $echon " downloading$echoc"
319       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
320     fi
321     $echon " compiling$echoc"
322     (cd $HOME$sub/lib/emacs;
323       $emacs >/dev/null 2>&1 --no-site-file --batch \
324         --eval '(byte-compile-file "'"$elib.el"'")')
325     echo " done."
326   fi
327 done
328 echo "  all done."
329
330 $echon "Setting up Emacs configuration:$echoc"
331 $echon " linking$echoc"
332 for f in dot-emacs.el Makefile; do
333   set -- $(echo $link | tr : ' ')
334   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
335   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
336 done
337 $echon " compiling$echoc"
338 { cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
339 echo " done."
340
341 ###----- That's all, folks --------------------------------------------------